# -*- coding: utf-8 -*-
#
#       libraryupdatethread.py
#
#       Copyright © 2011, 2014 Brandon Invergo <brandon@invergo.net>
#
#       This file is part of Grotesque.
#
#       Grotesque is free software: you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation, either version 3 of the License, or
#       (at your option) any later version.
#
#       Grotesque is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with Grotesque.  If not, see <http://www.gnu.org/licenses/>.

import os

from gi.repository import Gtk


def update_library(library, dialog, update, settings, update_response):
    row_iter = library.list_store.get_iter_first()
    while row_iter:
        dialog.progressbar.pulse()
        yield True
        story = library.list_store.get_value(row_iter, 15)
        if update == '0.9.3':
            if story.ifid is None:
                row_iter = library.list_store.iter_next(row_iter)
                continue
            if update_response == Gtk.ResponseType.YES:
                pass
            coverart_dir = settings.coverart_dir
            for ext in ['jpg', 'jpeg', 'png']:
                coverart_file = os.path.join(
                    coverart_dir, '.'.join([story.ifid, ext]))
                if os.path.exists(coverart_file):
                    story.coverart = coverart_file
                    break
            if story.author:
                authors = library.parse_list_str(story.author)
                for author in authors:
                    author_real_name = author.split('(')[0]
                    if author_real_name == '':
                        continue
                    library.author_store.counter_decr(
                        author_real_name.strip().lower())
                    library.author_store.counter_incr(author_real_name)
            if story.genre:
                genres = library.parse_list_str(story.genre)
                for genre in genres:
                    library.genre_store.counter_decr(genre.strip().lower())
                    library.genre_store.counter_incr(genre.strip())
            if story.group:
                library.group_store.counter_decr(story.group.lower())
                library.group_store.counter_incr(story.group)
            if story.series:
                library.series_store.counter_decr(story.series.lower())
                library.series_store.counter_incr(story.series)
            if story.forgiveness:
                library.forgiveness_store.counter_decr(
                    story.forgiveness.lower())
                library.forgiveness_store.counter_incr(story.forgiveness)
        dialog.progressbar.pulse()
        yield True
        row_iter = library.list_store.iter_next(row_iter)
    dialog.response(Gtk.ResponseType.OK)
    yield False
